/*******************************************************************************
* File Name: SoftLatch.h  
* Version 1.80
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_CONTROL_REG_SoftLatch_H) /* CY_CONTROL_REG_SoftLatch_H */
#define CY_CONTROL_REG_SoftLatch_H

#include "cytypes.h"

    
/***************************************
*     Data Struct Definitions
***************************************/

/* Sleep Mode API Support */
typedef struct
{
    uint8 controlState;

} SoftLatch_BACKUP_STRUCT;


/***************************************
*         Function Prototypes 
***************************************/

void    SoftLatch_Write(uint8 control) ;
uint8   SoftLatch_Read(void) ;

void SoftLatch_SaveConfig(void) ;
void SoftLatch_RestoreConfig(void) ;
void SoftLatch_Sleep(void) ; 
void SoftLatch_Wakeup(void) ;


/***************************************
*            Registers        
***************************************/

/* Control Register */
#define SoftLatch_Control        (* (reg8 *) SoftLatch_Sync_ctrl_reg__CONTROL_REG )
#define SoftLatch_Control_PTR    (  (reg8 *) SoftLatch_Sync_ctrl_reg__CONTROL_REG )

#endif /* End CY_CONTROL_REG_SoftLatch_H */


/* [] END OF FILE */
