/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#include <string.h>

#include "project.h"

// Union to help converting variable sizes and endianesses issues we can stumble upon
// when reading counters and writing to (or reading from) module registers which
// must remain compatible with xxxx

typedef union {
    uint32	CnvDWord;
    uint16	CnvWord[2];
    uint8	CnvByte[4];
} EndConv;

#define MAXREGS 8

// nevermind the error.. looks like a psoc creator bug spanning through versions
// it's a valid keil definition and asignment

volatile	uint8	xdata		EncModWrRegs[MAXREGS]	_at_	0x0010;
volatile	uint8	xdata		EncModRdRegs[MAXREGS]	_at_	0x0030;

uint8   xdata   trashme;

bit	LatchX  =  1;

EndConv CnvHelper;

/* DMA Configuration for Counter Reading DMA channels */
#define CTRCAP_DMA_BYTES_PER_BURST 4                        // will transfer 4 bytes before releasing the spoke
#define CTRCAP_DMA_REQUEST_PER_BURST 1                      // each DMA transfer needs a request
#define CTRCAP_DMA_SRC_BASE (CYDEV_PERIPH_BASE)
#define CTRCAP_DMA_DST_BASE (CYDEV_SRAM_BASE)

/* Variable declarations for Counter Reading DMA Channel */
uint8 XaxDMA_Chan;
uint8 XaxDMA_TD[2];

#define SoftCapture                
    
//
//  Program entry. 
//

int main( void )
{
	
 uint8	data	i;
 uint32	xdata	EncDat[4];
 uint32 xdata   ctrval;

	
    /* Place your initialization/startup code here (e.g. MyInst_Start()) */

	// start the counter
	XaxCtr_Start(); 
	
	/* Init Module Registers */
	for( i = 0; i < MAXREGS; i++ )
	{
		EncModWrRegs[i] = 0;
		EncModRdRegs[i] = 0;
	}
		
    
//===============================================================================================================
// DMA channels for transferring the Counters capture to the Module register
    
#if (defined(__C51__))
 	XaxDMA_Chan = XaxCDMA_DmaInitialize(CTRCAP_DMA_BYTES_PER_BURST, CTRCAP_DMA_BYTES_PER_BURST, 
       	HI16(CTRCAP_DMA_SRC_BASE), HI16(CTRCAP_DMA_DST_BASE));   
     	
#else /* PSoC 5 */ 
 	XaxDMA_Chan = XaxCDMA_ChanDMA_DmaInitialize(CTRCAP_DMA_BYTES_PER_BURST, CTRCAP_DMA_BYTES_PER_BURST, 
    	HI16(CTRCAP_DMA_SRC_BASE), HI16(CTRCAP_DMA_DST_BASE));    
#endif    

	XaxDMA_TD[0] = CyDmaTdAllocate();
    XaxDMA_TD[1] = CyDmaTdAllocate();
    
    // transfer 3 bytes from 24-bit counter to our working register
	CyDmaTdSetConfiguration(XaxDMA_TD[0], 3, XaxDMA_TD[1], CY_DMA_TD_INC_DST_ADR | CY_DMA_TD_INC_SRC_ADR | CY_DMA_TD_AUTO_EXEC_NEXT);
    CyDmaTdSetAddress(XaxDMA_TD[0], LO16((uint32)XaxCtr_STATICCOUNT_LSB_PTR), LO16((uint32)&EncModRdRegs[0]) );
    
    // read counter status register to clear the sticky capture bit. It's just 1 byte which completes the 4-byte burst size. 
	CyDmaTdSetConfiguration(XaxDMA_TD[1], 1, 0, 0 );	
	CyDmaTdSetAddress(XaxDMA_TD[1], LO16((uint32)XaxCtr_STATUS_PTR), LO16((uint32)&trashme) );		
    
	CyDmaChSetInitialTd(XaxDMA_Chan, XaxDMA_TD[0]);
	
	CyDmaChEnable(XaxDMA_Chan, 1);      // preserve TD
    
//===============================================================================================================


    CyGlobalIntEnable;				/* Uncomment this line to enable global interrupts. */

    EncModWrRegs[4] = 0x20;         // ENABLE SOFT LATCHING OF THE COUNTER
	
    do
    {

            // write a value into the counter if needed. EncModWrRegs[0] through EncModWrRegs[2] (a 24-bit value) are set to 0.
			CnvHelper.CnvDWord = CY_GET_REG24(&EncModWrRegs[0]);
			// now complement ms BIT of the 24-bit word so we get binary offset from 2's complement. Our counter
			// uses Binary Offset.
			CnvHelper.CnvByte[1] ^= 0x80;	
			
			if( LatchX == 1 ) {                                             // loads the counter with half count if latch is requested
			    XaxCtr_CONTROL &= ((uint8)(~XaxCtr_CTRL_ENABLE));
			    CY_SET_REG24(XaxCtr_COUNTER_LSB_PTR, CnvHelper.CnvDWord);	//XaxCtr_WriteCounter( CnvHelper.CnvDWord );
				XaxCtr_CONTROL |= XaxCtr_CTRL_ENABLE;                				
			    //	XaxCtr_ClearFIFO(); 
                LatchX = 0;
             }   
																// from another encoder module or a...
			if( EncModWrRegs[4] & 0x20 )                        // Soft Latch Request
                {			
             
                    SoftLatch_Control = 0x01;
                    ;                                       // waste some time to stretch a bit the capture pulse
                    SoftLatch_Control = 0x00;                                
                }
            
                ctrval = CY_GET_REG24(XaxCtr_COUNTER_LSB_PTR);
            
            ;                                              // so we can pút a break here to check out capture & DMA transfer
		
    } while( 1 );	/* main loop */

	// coming code is kind of purely formal because it is never reached under normal circumstances
		
	XaxCtr_Stop();

}

/* [] END OF FILE */
	